

#include <stdio.h>
#include "spnhdr.h"
#include "strmhdr.h"

extern int get_int () ;

typedef float  UNPACK [48] ;

static void get_site (site, rec)
UNPACK site ;
int rec [] ;
{
  int i ;

  for (i = 0; i < 24; i++)
  {
    int pair, x, y ;

    pair = get_int (rec [i]) ;

    x = pair & 0xffff ;
    if (x > 0x7fff) x -= 0x10000 ;
    y = (pair >> 16) & 0xffff ;
    if (y > 0x7fff) y -= 0x10000 ;

    site [ 2 * i     ] = ((float) x) / 0x7fff ;
    site [(2 * i) + 1] = ((float) y) / 0x7fff ;
  }
}

int elem (nlist, list, value)
int nlist, list [], value ;
{
  int i ;

  for (i = 0; i < nlist; i++)
    if (list [i] == value) return 1 ;
  return 0 ;
}

int iconv (i, l_space, l_time, l_x, l_y, l_z)
/*
  `i' is the position in the file.  Result is position
  in a straight array.
*/
int i, l_space, l_time, l_x, l_y, l_z ;
{
  int i_t, i_s, i_x, i_yz, i_y, i_z ;

  i_t  = i / l_space ;
  i_s  = i % l_space ;
  i_x  = i_s / (l_y * l_z) ;
  i_yz = i_s % (l_y * l_z) ;
  i_y  = i_yz / l_z ;
  i_z  = i_yz % l_z ;
  if (i_t < (l_time / 2))
    i_t = (2 * i_t) + ((i_x + i_y + i_z) % 2) ;
  else
    i_t = (2 * (i_t - (l_time / 2))) + (1 - ((i_x + i_y + i_z) % 2)) ;
  return (l_space * i_t) + i_s ;
}

void print_site (data1, l_time, l_space, l_x, l_y, l_z, nsites, sites)
DATA  *data1 ;
int l_time, l_space, l_x, l_y, l_z, nsites, sites [] ;
{
  int t, x ;

  for (t = 0; t < l_time; t++)
  {
    int index   = l_space * t ;

    for (x = 0; x < l_space; x++)
    {
      int *rec ;

      read_field_record (data1, (char **) &rec) ;
      if (elem (nsites, sites, iconv (index, l_space, l_time, l_x, l_y, l_z)))
      {
	UNPACK unpacked ;
	int d, c ;

	get_site     (unpacked, rec) ;

	printf ("%d (%d)\n", iconv (index, l_space, l_time, l_x, l_y, l_z), index) ;
	for (d = 0; d < 4; d++)
	{
	  for (c = 0; c < 6; c++)
	    printf ("%e  %e\n",
		    unpacked [12 * d + 2 * c],
		    unpacked [12 * d + 2 * c + 1]) ;
	  printf ("\n") ;
	}
	printf ("\n") ;
      }
      index++ ;
    }
  }
}

